library lnk;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  SysUtils,
  Classes,
  Windows,
  ShlObj,
  ActiveX,
  ComObj,
  Registry,
  syncobjs;

procedure setup(prog, uns, jar, menu: PChar); stdcall;
var
  MyObject  : IUnknown;
  MySLink   : IShellLink;
  MyPFile   : IPersistFile;
  FileName  : String;
  Directory : String;
  WFileName : WideString;
  MyReg     : TRegIniFile;
  ps1,ps2,sn,path :   string;
  f         :   System.text;
begin
  CoInitialize(Nil);
  MyObject := CreateComObject(CLSID_ShellLink);
  MySLink  := MyObject as IShellLink;
  MyPFile  := MyObject as IPersistFile;
  FileName := prog;
  path := ExtractFilePath(FileName);
  with MySLink do
  begin
    SetArguments('');
    SetPath(PChar(FileName));
    SetWorkingDirectory(PChar(ExtractFilePath(FileName)));
  end;
  //   .
  MyReg := TRegIniFile.Create('Software\MicroSoft\Windows\CurrentVersion\Explorer');
  Directory := MyReg.ReadString('Shell Folders','Desktop','');
  WFileName := Directory+'\';
  WFileName := WFileName+jar;
  WFileName := WFileName+'.lnk';
  MyPFile.Save(PWChar(WFileName),False);
  ps1:=string(WFileName);
  //    .
  Directory :=MyReg.ReadString('Shell Folders', 'Programs','') + '\';
  Directory:=Directory+menu;
  WFileName := Directory+'\';
  WFileName := WFileName+jar;
  WFileName := WFileName+'.lnk';
  CreateDir(Directory);
  ps2:=Directory+'\';
  MyPFile.Save(PWChar(WFileName),False);
  //***************************************
  MyObject := CreateComObject(CLSID_ShellLink);
  MySLink := MyObject as IShellLink;
  MyPFile := MyObject as IPersistFile;
  FileName := uns;
  path := ExtractFilePath(FileName);
  with MySLink do
  begin
    SetArguments('');
    SetPath (PChar(FileName));
    SetWorkingDirectory (PChar (ExtractFilePath(FileName)))
  end;
  WFileName := Directory+'\';
  WFileName := WFileName+'UNFILES.lnk';
  MyPFile.Save (PWChar (WFileName),False);
  MyReg.Free;
  // ,   
  //    .
  sn:=path+'perebros.lk';
  AssignFile(f,sn);
  rewrite (f);
  writeln(f,ps1);
  writeln(f,ps2);
  CloseFile(f);
end;
//********************************
Procedure DLLMain (r:DWORD);
begin
end;

Exports
    setup;
begin
  DLLProc:=@DLLMain;
  DLLMain (dll_Process_Attach);
end.

